#include"motor.h"

Motor::Motor(int e, int a,int b,int c,float f)
{
  en=e; // Motorpins merken
  m1=a;
  m2=b;
  i1=c;
  mmps=f;
  
  pinMode(en,OUTPUT); // Pins konfigurieren
  pinMode(m1,OUTPUT);
  pinMode(m2,OUTPUT);
  pinMode(i1,INPUT_PULLUP);

  talt=micros(); // Zeit in Mikrosekunden
}

void Motor::aus()
{
  digitalWrite(en,LOW);
  ferri=0.0;
  fsoll=0.0;
}

void Motor::fPID()
{
  double err=fsoll-f;
  double dt=double(micros()-ftalt)/1000000.0;
  ferri=ferri+err*dt;
  //ferri=constrain(ferri,-50.0,50.0);

  int p=err*fp+ferri*fi;
  p=constrain(p,-255,255);
  power(p);
  
  ftalt=micros();  // Zeit merken
}

void Motor::setVSoll(double vs)
{
  fsoll=vs/mmps;
}

void Motor::setFSoll(double fs)
{
  fsoll=fs;
}

double Motor::getS()
{
  return steps*mmps;
}

double Motor::getV() //Geschwindigkeit in mm/s
{
  if (micros()-talt>40000) f=0.0;
  return f*mmps;
}

void Motor::richtung()
{
  if (mpower>0)
  {
    steps++;
  }
  else if (mpower<0)
  {
    steps--;
  }

  tneu=micros(); // Aktuelle Zeit;
  if (tneu-talt>10000) // 10 ms
    {  
      f=1000000.0*float(steps-stepsalt)/float(tneu-talt);
      talt=tneu;
      stepsalt=steps;
    }
}

long Motor::getSteps()
{
  return steps;
}

float Motor::getF()
{
  if (micros()-talt>100000) f=0.0;
  return f;
}

Motor::power(int p)
{
  p=constrain(p,-255,255);
  mpower=p;
  if(p>=0)
  {
    analogWrite(en,p);
    digitalWrite(m1,HIGH);
    digitalWrite(m2,LOW);
  }
  else
  {
    analogWrite(en,-p);
    digitalWrite(m2,HIGH);
    digitalWrite(m1,LOW);
  }
}